regina::NTriSolidTorus Class Reference
Standard Triangulations and Subcomplexes

Represents a three-tetrahedron triangular solid torus in a triangulation. More...

`#include <subcomplex/ntrisolidtorus.h>`

Inheritance diagram for regina::NTriSolidTorus:

## Public Member Functions

virtual | ~NTriSolidTorus ()
| Destroys this solid torus. More...
NTriSolidTorus * | clone () const
| Returns a newly created clone of this structure. More...
NTetrahedron * | getTetrahedron (int index) const
| Returns the requested tetrahedron in this solid torus. More...
NPerm4 | getVertexRoles (int index) const
| Returns a permutation represeting the role that each vertex of the requested tetrahedron plays in the solid torus. More...
bool | isAnnulusSelfIdentified (int index, NPerm4 *roleMap) const
| Determines whether the two triangles of the requested annulus are glued to each other. More...
unsigned long | areAnnuliLinkedMajor (int otherAnnulus) const
| Determines whether the two given annuli are linked in a particular fashion by a layered chain. More...
unsigned long | areAnnuliLinkedAxis (int otherAnnulus) const
| Determines whether the two given annuli are linked in a particular fashion by a layered chain. More...
NManifold * | getManifold () const
| Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented. More...
NAbelianGroup * | getHomologyH1 () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the name of this triangulation as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the name of this triangulation in TeX format to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
Public Member Functions inherited from regina::NStandardTriangulation
virtual | ~NStandardTriangulation ()
| A destructor that does nothing. More...
std::string | getName () const
| Returns the name of this specific triangulation as a human-readable string. More...
std::string | getTeXName () const
| Returns the name of this specific triangulation in TeX format. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
Public Member Functions inherited from regina::ShareableObject
| ShareableObject ()
| Default constructor that does nothing. More...
virtual | ~ShareableObject ()
| Default destructor that does nothing. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Static Public Member Functions

static NTriSolidTorus * | formsTriSolidTorus (NTetrahedron *tet, NPerm4 useVertexRoles)
| Determines if the given tetrahedron forms part of a three-tetrahedron triangular solid torus with its vertices playing the given roles in the solid torus. More...
Static Public Member Functions inherited from regina::NStandardTriangulation
static NStandardTriangulation * | isStandardTriangulation (NComponent *component)
| Determines whether the given component represents one of the standard triangulations understood by Regina. More...
static NStandardTriangulation * | isStandardTriangulation (NTriangulation *tri)
| Determines whether the given triangulation represents one of the standard triangulations understood by Regina. More...

## Additional Inherited Members

Protected Member Functions inherited from regina::boost::noncopyable
| noncopyable ()
| A constructor which does nothing. More...
| ~noncopyable ()
| A destructor which does nothing. More...

## Detailed Description

Represents a three-tetrahedron triangular solid torus in a triangulation.

A three-tetrahedron triangular solid torus is a three-tetrahedron triangular prism with its two ends identified.

The resulting triangular solid torus will have all edges as boundary edges. Three of these will be axis edges (parallel to the axis of the solid torus). Between the axis edges will be three annuli, each with two internal edges. One of these internal edges will meet all three tetrahedra (the major edge) and one of these internal edges will only meet two of the tetrahedra (the minor edge).

Assume the axis of the layered solid torus is oriented. The three major edges together form a loop on the boundary torus. This loop can be oriented to run around the solid torus in the same direction as the axis; this then induces an orientation on the boundary of a meridinal disc. Thus, using an axis edge as longitude, the three major edges will together form a (1,1) curve on the boundary torus.

We can now orient the minor edges so they also run around the solid torus in the same direction as the axis, together forming a (2, -1) curve on the boundary torus.

Finally, the three tetrahedra can be numbered 0, 1 and 2 in an order that follows the axis, and the annuli can be numbered 0, 1 and 2 in an order that follows the meridinal disc boundary so that annulus i does not use any faces from tetrahedron i.

Note that all three tetrahedra in the triangular solid torus must be distinct.

All optional NStandardTriangulation routines are implemented for this class.

## Constructor & Destructor Documentation

regina::NTriSolidTorus::~NTriSolidTorus | ( |  | ) |

inline virtual

Destroys this solid torus.

## Member Function Documentation

unsigned long regina::NTriSolidTorus::areAnnuliLinkedAxis | ( | int | otherAnnulus | ) | const

Determines whether the two given annuli are linked in a particular fashion by a layered chain.

In this scenario, one of the given annuli meets both faces of the top tetrahedron and the other annulus meets both faces of the bottom tetrahedron of the layered chain.

To be identified by this routine, the layered chain (described by NLayeredChain) must be attached as follows. We shall refer to the two hinge edges of the layered chain as first and second.

The two diagonals of the layered chain (between the two top faces and between the two bottom faces) should correspond to the two directed major edges of the two annuli, with the major edges both pointing from top hinge edge to bottom hinge edge. The other boundary edges of the layered chain that are not hinge edges should correspond to the two directed minor edges of the two annuli, with the minor edges both pointing from bottom hinge edge to top hinge edge. The hinge edges themselves should correspond to the axis edges of the triangular solid torus (this correspondence is determined by the previous identifications; the axis edge between the two annuli will be identified to both of the others in reverse).

Parameters

  otherAnnulus | the annulus on the solid torus boundary not to be examined; this must be 0, 1 or 2.

Returns
  the number of tetrahedra in the layered chain if the two annuli are linked as described, or 0 otherwise.

unsigned long regina::NTriSolidTorus::areAnnuliLinkedMajor | ( | int | otherAnnulus | ) | const

Determines whether the two given annuli are linked in a particular fashion by a layered chain.

In this scenario, both of the given annuli meet one face of the top tetrahedron and one face of the bottom tetrahedron of the layered chain.

To be identified by this routine, the layered chain (described by NLayeredChain) must be attached as follows. The two directed major edges of the two annuli should correspond to the two hinge edges of the layered chain (with both hinge edges pointing in the same direction around the solid torus formed by the layered chain). The two directed diagonals of the layered chain (between the two top faces and between the two bottom faces, each pointing in the opposite direction to the hinge edges around the solid torus formed by the layered chain) should be identified and must correspond to the (identified) two directed minor edges of the two annuli. The remaining boundary edges of the layered chain should correspond to the axis edges of the triangular solid torus (this correspondence is determined by the previous identifications).

Parameters

  otherAnnulus | the annulus on the solid torus boundary not to be examined; this must be 0, 1 or 2.

Returns
  the number of tetrahedra in the layered chain if the two annuli are linked as described, or 0 otherwise.

NTriSolidTorus* regina::NTriSolidTorus::clone | ( |  | ) | const

Returns a newly created clone of this structure.

Returns
  a newly created clone.

static NTriSolidTorus* regina::NTriSolidTorus::formsTriSolidTorus | ( | NTetrahedron * | tet,
|  | NPerm4 | useVertexRoles
| ) |  |

static

Determines if the given tetrahedron forms part of a three-tetrahedron triangular solid torus with its vertices playing the given roles in the solid torus.

Note that the six boundary triangles of the triangular solid torus need not be boundary triangles within the overall triangulation, i.e., they may be identified with each other or with faces of other tetrahedra.

Parameters

  tet | the tetrahedron to examine.
  useVertexRoles | a permutation describing the role each tetrahedron vertex must play in the solid torus; this must be in the same format as the permutation returned by getVertexRoles().

Returns
  a newly created structure containing details of the solid torus with the given tetrahedron as tetrahedron 0, or `null` if the given tetrahedron is not part of a triangular solid torus with the given vertex roles.

NAbelianGroup* regina::NTriSolidTorus::getHomologyH1 | ( |  | ) | const

virtual

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling NTriangulation::getHomologyH1() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this NStandardTriangulation describes an entire NTriangulation (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling NTriangulation::getHomologyH1() upon the associated real triangulation.

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented from regina::NStandardTriangulation.

NManifold* regina::NTriSolidTorus::getManifold | ( |  | ) | const

virtual

Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented.

If the 3-manifold cannot be recognised then this routine will return 0.

The details of which standard triangulations have 3-manifold recognition routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

It is expected that the number of triangulations whose underlying 3-manifolds can be recognised will grow between releases.

The 3-manifold will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the underlying 3-manifold.

Reimplemented from regina::NStandardTriangulation.

NTetrahedron * regina::NTriSolidTorus::getTetrahedron | ( | int | index | ) | const

inline

Returns the requested tetrahedron in this solid torus.

See the general class notes for further details.

Parameters

  index | specifies which tetrahedron in the solid torus to return; this must be 0, 1 or 2.

Returns
  the requested tetrahedron.

NPerm4 regina::NTriSolidTorus::getVertexRoles | ( | int | index | ) | const

inline

Returns a permutation represeting the role that each vertex of the requested tetrahedron plays in the solid torus.

The permutation returned (call this `p`) maps 0, 1, 2 and 3 to the four vertices of tetrahedron index so that the edge from `p[0]` to `p[3]` is an oriented axis edge, and the path from vertices `p[0]` to `p[1]` to `p[2]` to `p[3]` follows the three oriented major edges. In particular, the major edge for annulus index will run from vertices `p[1]` to `p[2]`. Edges `p[0]` to `p[2]` and `p[1]` to `p[3]` will both be oriented minor edges.

Note that annulus `index+1` uses face `p[1]` of the requested tetrahedron and annulus `index+2` uses face `p[2]` of the requested tetrahedron. Both annuli use the axis edge `p[0]` to `p[3]`, and each annulus uses one other major edge and one other minor edge so that (according to homology) the axis edge equals the major edge plus the minor edge.

See the general class notes for further details.

Parameters

  index | specifies which tetrahedron in the solid torus to examine; this must be 0, 1 or 2.

Returns
  a permutation representing the roles of the vertices of the requested tetrahedron.

bool regina::NTriSolidTorus::isAnnulusSelfIdentified | ( | int | index,
|  | NPerm4 * | roleMap
| ) |  | const

Determines whether the two triangles of the requested annulus are glued to each other.

If the two triangles are glued, parameter roleMap will be modified to return a permutation describing how the vertex roles are glued to each other. This will describe directly how axis edges, major edges and minor edges map to each other without having to worry about the specific assignment of tetrahedron vertex numbers. For a discussion of vertex roles, see getVertexRoles().

Note that annulus `index` uses faces from tetrahedra `index+1` and `index+2`. The gluing permutation that maps vertices of tetrahedron `index+1` to vertices of tetrahedron `index+2` will be `getVertexRoles(index+2) * roleMap * getVertexRoles(index+1).inverse()`.

Parameters

  index | specifies which annulus on the solid torus boundary to examine; this must be 0, 1 or 2.
  roleMap | a pointer to a permutation that, if this routine returns `true`, will be modified to describe the gluing of vertex roles. This parameter may be `null`.

Returns
  `true` if and only if the two triangles of the requested annulus are glued together.

std::ostream & regina::NTriSolidTorus::writeName | ( | std::ostream & | out | ) | const

inline virtual

Writes the name of this triangulation as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

std::ostream & regina::NTriSolidTorus::writeTeXName | ( | std::ostream & | out | ) | const

inline virtual

Writes the name of this triangulation in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

void regina::NTriSolidTorus::writeTextLong | ( | std::ostream & | out | ) | const

inline virtual

Writes this object in long text format to the given output stream.

The output should provide the user with all the information they could want. The output should be human-readable, should not contain extremely long lines (so users can read the output in a terminal), and should end with a final newline.

The default implementation of this routine merely calls writeTextShort() and adds a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::ShareableObject.

The documentation for this class was generated from the following file:

- subcomplex/ntrisolidtorus.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).